#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2023 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Corrade/Containers/ArrayView.h>
#include <Corrade/Containers/StringView.h>

#include "AbstractUnrealProperty.h"

#include "../Types/FloatProperty.h"

namespace Gvas { namespace Serialisers {

class FloatProperty : public AbstractUnrealProperty {
    public:
        using ptr = Containers::Pointer<FloatProperty>;

        auto types() -> StringArrayView override;

        auto deserialise(Containers::StringView name, Containers::StringView type, std::size_t value_length,
                         BinaryReader& reader, PropertySerialiser& serialiser)
                         -> Types::UnrealPropertyBase::ptr override;

        bool serialise(Types::UnrealPropertyBase::ptr& prop, std::size_t& bytes_written, BinaryWriter& writer,
                       PropertySerialiser& serialiser) override;
};

}}
